<?
	/***************************************************************
	*  Copyright notice
	*
	*  (c) 2005 Michael Lehnert ()
	*  All rights reserved
	*
	*  This script is part of the TYPO3 project. The TYPO3 project is
	*  free software; you can redistribute it and/or modify
	*  it under the terms of the GNU General Public License as published by
	*  the Free Software Foundation; either version 2 of the License, or
	*  (at your option) any later version.
	*
	*  The GNU General Public License can be found at
	*  http://www.gnu.org/copyleft/gpl.html.
	*
	*  This script is distributed in the hope that it will be useful,
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	*  GNU General Public License for more details.
	*
	*  This copyright notice MUST APPEAR in all copies of the script!
	***************************************************************/
	/**
	* Module 'informer' for the 'ml_informer' extension.
	*
	* @author Michael Lehnert <>
	*/
	 
	 
	 
	// DEFAULT initialization of a module [BEGIN]
	unset($MCONF);
	require ("conf.php");
	require ($BACK_PATH."init.php");
	require ($BACK_PATH."template.php");
	$LANG->includeLLFile("EXT:ml_informer/mod1/locallang.php");
	#include ("locallang.php");
	require_once (PATH_t3lib."class.t3lib_scbase.php");
	require_once (PATH_t3lib.'class.t3lib_tceforms.php');
	$BE_USER->modAccess($MCONF, 1); // This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]
	 
	class tx_mlinformer_module1 extends t3lib_SCbase {
		var $pageinfo;
		 
		/**
		*
		*/
		function init() {
			global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;
			 
			parent::init();
			 
			/*
			if (t3lib_div::_GP("clear_all_cache")) {
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
			}
			*/
		}
		 
		/**
		* Adds items to the->MOD_MENU array. Used for the function menu selector.
		*/
		function menuConfig() {
			global $LANG, $BE_USER;
						
			if ($BE_USER->user['admin'])    {
				$this->MOD_MENU = Array (
				"function" => Array (
					"show_pages" => $LANG->getLL("show_pages"),
					"show_content" => $LANG->getLL("show_content"),
					"new_publisher" => $LANG->getLL("new_publisher"),
					"edit_publisher" => $LANG->getLL("edit_publisher"),
					),
					               'showRootline' => 1,
				);
				parent::menuConfig();
			} else {
				$this->MOD_MENU = Array (
				"function" => Array (
					"show_pages" => $LANG->getLL("show_pages"),
					"show_content" => $LANG->getLL("show_content"),
					),
					               'showRootline' => 1,
				);
				parent::menuConfig();
			}
		}
		 
		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
		/**
		* Main function of the module. Write the content to $this->content
		*/
		function main() {
			global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;
			 
			$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id, $this->perms_clause);
						 
				// Draw the header.
				$this->doc = t3lib_div::makeInstance("mediumDoc");
				$this->doc->backPath = $BACK_PATH;
				$this->doc->form = '<form action="" method="POST">';
				 
				// JavaScript
				$this->doc->JScode = '
					<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL) {
					document.location = URL;
					}
					</script>
					';
				$this->doc->postCode = '
					<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
					</script>
					';
				 
				$headerSection = $this->doc->getHeader("pages", $this->pageinfo, $this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"], 50);
				 
				$this->content .= $this->doc->startPage($LANG->getLL("title"));
				$this->content .= $this->doc->header($LANG->getLL("title"));
				$this->content .= $this->doc->spacer(5);
				$this->content .= $this->doc->section("", $this->doc->funcMenu($headerSection, t3lib_BEfunc::getFuncMenu($this->id, "SET[function]", $this->MOD_SETTINGS["function"], $this->MOD_MENU["function"])));
				$this->content .= $this->doc->divider(5);
				 
				 
				// Render content:
				$this->moduleContent();
				
				
				// ShortCut
				if ($BE_USER->mayMakeShortcut()) {
					$this->content .= $this->doc->spacer(20).$this->doc->section("", $this->doc->makeShortcutIcon("id", implode(",", array_keys($this->MOD_MENU)), $this->MCONF["name"]));
				}
				 
				$this->content .= $this->doc->spacer(10);
		}
		
		/**
		* Prints out the module HTML
		*/
		function printContent() {
			 
			$this->content .= $this->doc->endPage();
			echo $this->content;
		}
		
		/**
		* Check, if the current BE_user is a publisher!
		*/
		function getUser() {
			global $BE_USER;
			
			$userID = $BE_USER->user['uid'];
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('tx_mlinformer_is_publisher, username, tx_mlinformer_editors', 'be_users', 'uid='.$userID, '', '', '');
			$logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
			$test = $logRow['tx_mlinformer_is_publisher'];
				
			if($test == 1){
				$result = array (
					'userid' => $userID,
					'username' => $logRow['username'],
					'editors' => $logRow['tx_mlinformer_editors'],
					'test' => true
				);
			} else {
				$result = array (
					'test' => false
				);
			}
			
			return $result;
		}

		/**
		* Generates the module content
		*/
		function moduleContent() {
			global $TSFE, $be_user, $LANG;
			switch((string)$this->MOD_SETTINGS["function"]) {
				case show_content:
				$test = $this->getUser();

				if($test['test']){
					$mode = '1,2';
					$mltable = '';
					$content = $this->getRecentChangesTable($mode, $mltable);
					$this->content .= $this->doc->section("Latest edited/created content:", $content, 0, 1);
				 } else {
					$content = $LANG->getLL("noUser");
					$this->content .= $this->doc->section("", $content, 0, 1);
				}

				break;
				case show_pages:
				$test = $this->getUser();

				if($test['test']){
					$mode = '1,2';
					$mltable = 'pages';
					$content = $this->getRecentChangesTable($mode, $mltable);
					$this->content .= $this->doc->section("Latest edited/created pages:", $content, 0, 1);
				} else {
					$content = $LANG->getLL("noUser");
					$this->content .= $this->doc->section("", $content, 0, 1);
				}

				break;
				case new_publisher:
				$content ="
					<form method='get'>
					<select size='5' multiple='multiple' name='be_user[]'  style='width:250px;'>";
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username,uid', 'be_users', 'deleted=0', '', '', '');
				while ($logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
					$content .= "<option value='".$logRow['uid']."'>".$logRow['username']."</option>"; 
				}	
				$content .= "</select><br><br>
					     <input type='image' name='saveusers' src='../../../../typo3/gfx/savedok.gif' value='save' />
						 <input type='hidden' name='saveusers' value='save' /></form><br><br>";
				
				$this->content .= $this->doc->section("List of all BE - Users:", $content, 0, 1);
				
				$n=0;
				$test = t3lib_div::_POST('saveusers');
				if($test == 'save'){
					$content = "ie";
					$update_array = array(
					 	'tx_mlinformer_is_publisher' => 1
					);
					$content = "<form method='GET'>";
										
					while($_POST['be_user'][$n]){
						$update = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('be_users','uid='.$_POST['be_user'][$n],$update_array);
						$be_user[$n] = $_POST['be_user'][$n];
						$res_user = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username', 'be_users', 'uid='.$_POST['be_user'][$n], '', '', '');
						$logRow_user = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_user);
						$username = $logRow_user['username'];
						
						$content .= "<input type='hidden' name='be_user[]' value=".$_POST['be_user'][$n].">";
						$content .= "<br><br>Publisher: ".$username."<br><select size='3' multiple='multiple' name='".$username."[]'  style='width:250px;'>";
						$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('title,uid', 'be_groups', '', '', '', '');
						while($logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
							$content .= "<option value=".$logRow['uid'].">".$logRow['title']."</option> ";
						}
						$content .= "</select>";							
						$n++;
					}
					$content .= "<br><input type='image' name='savegroups' src='../../../../typo3/gfx/savedok.gif' value='write' />
								 <input type='hidden' name='savegroups' value='write' /></form>";
					$this->content .= $this->doc->section("Select the BE - Usergroups for the Publisher:", $content, 0, 1);

										
				}
				
				
				$test_g = t3lib_div::_GET('savegroups');
				if($test_g == 'write'){
					$n=0;
					$m=0;
																
					while($_GET['be_user'][$n]){
						$res_user = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username', 'be_users', 'uid='.$_GET['be_user'][$n], '', '', '');
					        $logRow_user = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_user);
						$username = $logRow_user['username'];
											
						while($_GET[$username][$m]){
							$res_groups = $GLOBALS['TYPO3_DB']->exec_SELECTquery('TSconfig, non_exclude_fields', 'be_groups', 'uid='.$_GET[$username][$m], '', '', '');
							$logRow_groups = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_groups);
							$exc_fields = $logRow_groups['non_exclude_fields'];
							$TSconfig_groups = $logRow_groups['TSconfig'];
							
							$TSconfig_pattern1 = 'TCAdefaults.pages.hidden=1';
							$TSconfig_pattern2 = 'TCAdefaults.tt_content.hidden=1';
							if((strstr($TSconfig_groups,$TSconfig_pattern1))){
								$TSconfig_new = $TSconfig_groups;
								} else {
								$TSconfig_new .= $TSconfig_groups.' '.$TSconfig_pattern1;
								}
							 if((strstr($TSconfig_groups,$TSconfig_pattern2))){
							        $TSconfig_new = $TSconfig_groups;
								} else {
								$TSconfig_new .= $TSconfig_groups.' '.$TSconfig_pattern2;
								}
							
							$exc_fields_array = split(",",$exc_fields);
							$exc_fields_new = '';
							$c = 0;
							while($exc_fields_array[$c]){
								if($exc_fields_array[$c] != 'pages:hidden'){
									$exc_fields_new .= $exc_fields_array[$c].',';
								}
								$c++;
							}
							
							$update_array = array(
							       'TSconfig' => $TSconfig_new,
							       'non_exclude_fields' => $exc_fields_new
							       );
														   
							$update = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('be_groups','uid='.$_GET[$username][$m],$update_array);
							if($_GET[$username][$m+1]){
								$editors .= $_GET[$username][$m].",";
								$m++;
							} else {
								$editors .= $_GET[$username][$m];
								$m++;
							}									
						}
						$update_array = array(
							 'tx_mlinformer_editors' => $editors,
							 'TSconfig' => 'hallo'
						);							
						$update = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('be_users','uid='.$_GET['be_user'][$n],$update_array);
						$n++;
					}
				}
				break;
				case edit_publisher:
				if($_POST['publisher'] == 'delete'){
					$n = 0;
					$update_array = array(
						'tx_mlinformer_is_publisher' => 0
					);
					while($_POST['publisher_list'][$n]){
						$update = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('be_users','uid='.$_POST['publisher_list'][$n],$update_array);
					 	$n++;
					}
				}
						
				if($_GET['delete_groups'] == 'delete_g'){
				 	$n = 0;
					while($_GET['be_groups'][$n]){
					        $res_user = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username', 'be_users', 'uid='.$_GET['be_groups'][$n], '', '', '');
						$logRow_user = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_user);
						$username = $logRow_user['username'];
																		
						$res_groups = $GLOBALS['TYPO3_DB']->exec_SELECTquery('tx_mlinformer_editors', 'be_users', 'uid='.$_GET['be_groups'][$n], '', '', '');
						$logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_groups);
						$groups = $logRow['tx_mlinformer_editors'];
											
						$m=0;
						while($_GET[$username][$m]){
							$groups_array = split(",",$groups);
							if(count($groups_array) == 1){
								$groups = str_replace($_GET[$username][$m],'',$groups);
							} elseif ($groups_array[(count($groups_array)-1)] == $_GET[$username][$m]){
								$groups = str_replace(','.$_GET[$username][$m],'',$groups);				
							} else {
								$groups = str_replace($_GET[$username][$m].',','',$groups);	
							}
							$m++;
						}
						
						$update_array = array(
	                                        	'tx_mlinformer_editors' => $groups
						);							
						$update = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('be_users','uid='.$_GET['be_groups'][$n],$update_array);
						$res_groups = $GLOBALS['TYPO3_DB']->exec_SELECTquery('tx_mlinformer_editors', 'be_users', 'uid='.$_GET['be_groups'][$n], '', '', '');
						$logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_groups);
						if($logRow['tx_mlinformer_editors'] == ''){
							$update_array = array(
								'tx_mlinformer_is_publisher' => 0
							 );
							 $update = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('be_users','uid='.$_GET['be_groups'][$n],$update_array);
							}
						$n++;
					}
				}
				
				$content ="
					<form method='get'>
					<select size='5' multiple='multiple' name='publisher_list[]'  style='width:250px;'>";
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username,uid', 'be_users', 'tx_mlinformer_is_publisher = 1', '', '', '');
				while ($logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
					$content .= "<option value='".$logRow['uid']."'>".$logRow['username']."</option>";
				}
				$content .= "</select><br><br>".
				             "<input type='hidden' name='publisher' value='edit' />".
					     "<input type='image' name='publisher' value='edit' src='../../../../typo3/gfx/edit2.gif' title='edit publisher' />".
					     "</form><br><br>";
				$this->content .= $this->doc->section("List of all Publisher:: choose to edit", $content, 0, 1);
				
							
				if($_POST['publisher'] == 'edit'){
					$content = "<form method='GET'>";
					$n = 0;
					while($_POST['publisher_list'][$n]){
						$content .= "<input type='hidden' name='be_groups[]' value='".$_POST['publisher_list'][$n]."'/>";
						$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('username', 'be_users', 'uid='.$_POST['publisher_list'][$n], '', '', '');
						$logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
						$username = $logRow['username'];

						$content .= "<br><br>Publisher: ".$username."<br><select size='3' multiple='multiple' name='".$username."[]'  style='width:250px;'>";	
						$res_groups = $GLOBALS['TYPO3_DB']->exec_SELECTquery('tx_mlinformer_editors', 'be_users', 'uid='.$_POST['publisher_list'][$n], '', '', '');
						$logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_groups);
						$groups = $logRow['tx_mlinformer_editors'];
						$groups_array = split(",",$groups);
						$m = 0;
						while($groups_array[$m]){
							$res_groups = $GLOBALS['TYPO3_DB']->exec_SELECTquery('title', 'be_groups', 'uid='.$groups_array[$m], '', '', '');
							$logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_groups);
							$content .= "<option value=".$groups_array[$m].">".$logRow['title']."</option>";
							$m++;
						}
						$n++;
						$content .= "</select><br><br>";
					}
				$content .= "<input type='hidden' name='delete_groups' value='delete_g' />".
					"<input type='image' name='delete_groups' src='../../../../typo3/gfx/garbage.gif' value='delete_g' /></form><br><br>";
				$this->content .= $this->doc->section("List of all Editor - Groups:", $content, 0, 1);
				}
							
				break;
				
			}
		}
	

	/**
	* Get the last login of a user
	*/
	function lastlogin() {
		$user = $this->getUser();
		$username = $user['username'];

		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
						'sys_log.tstamp, sys_log.log_data',
						'sys_log',
						'sys_log.type=255 AND sys_log.action=2',
						'',
						'',
						''
					);
		$n=0;
		while($logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			$timestamp[$n] = $logRow['tstamp'];
			$logdata[$n] = $logRow['log_data'];
			$n++;
		}
				
		$n=0;
		$m=0;
		while($logdata[$n]){
			if((strstr($logdata[$n],$username)) == false){
			} else {
				$ts[$m] = $timestamp[$n];
				$m++;
			}
			$n++;
	}
	
	$t = count($ts);

		return $ts[($t-1)];
	}
		
	
	/**
	 * Render the table with recently changed records
	 *
	 * @param   string      Mode from $this->MOD_SETTINGS['function']
	 * @return  string      Rendered Table
	 */
	function getRecentChangesTable($mode, $mltable)   {
		global $BACK_PATH, $BE_USER, $LANG, $TCA;

			// Set sys_log actions depending on selected mode
		if ($mode=='new') {
			$action = '1';
		} elseif ($mode=='updated') {
			$action = '2';
		} else {
			$action = '1,2';
		}

			// Query sys_log for non-deleted pages only
		
		
		if($mltable == 'pages'){
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 'sys_log', "tablename = 'pages' AND event_pid>0 AND type=1 AND action=1 AND error=0", '', 'tstamp DESC', '200');
			
		} else {
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
						'sys_log.*',
						'sys_log,pages',
						"pages.uid=sys_log.event_pid AND tablename != 'pages'".
							' AND sys_log.event_pid>0 AND sys_log.type=1 AND sys_log.action IN ('.$action.') AND sys_log.error=0'.
							t3lib_BEfunc::deleteClause('pages'),
						'',
						'tstamp DESC',
						'200'
					);
		}


			// init table layout
		$tableLayout = array (
			'table' => array ('<table border="0" cellpadding="1" cellspacing="1" class="typo3-recent-edited">', '</table>'),
			'defRow' => array (
				'tr' => array('<tr class="bgColor4">','</tr>'),
				'defCol' => Array('<td valign="top">','</td>')
			)
		);

		$table = array();
		$tr = 0;

		$publisher = $this->getUser();
		if((strstr($groups_array,',')) == false){
			$groups_array[0] = $publisher['editors'];
		} else {
			$groups_array = split(",",$publisher['editors']);
		}
		
		$n=0;
		foreach ($groups_array as $value) {
			$res_gr = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid', 'be_users', 'usergroup='.$value,'','','');				
			while($logUser = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res_gr)) {
				$editor[$n] = $logUser['uid'];
				$n++;
			}
		}
		$editor = array_unique($editor);

		$n=0;
		while($logRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))    {

			$page_id = $logRow['event_pid'];
			$pageRow = t3lib_BEfunc::getRecord('pages', $page_id);

			if ((is_array($pageRow)) AND ($logRow['tstamp'] > $this->lastlogin())) {
				
				while($editor[$n]){
					if($logRow['userid'] == $editor[$n]){

							// Create output item for pages record
						$contentPageLink = $this->getItemFromRecord('pages', $pageRow);

							// Create output text describing the age
						$contentAge = t3lib_BEfunc::dateTimeAge($logRow['tstamp'], 1);


						$contentElementLink = '';
						$contentUser = '';
						
												
						$elementRow = t3lib_BEfunc::getRecord($logRow['tablename'], $logRow['recuid']);

								// If record is deleted continue with next log entry
						if (!is_array($elementRow)) {
							continue;
						}

						$contentElementLink = $this->getItemFromRecord($logRow['tablename'], $elementRow);
							

							// Create user item
						$userRow = t3lib_BEfunc::getRecord('be_users', $logRow['userid']);
						if(is_array($userRow)) {
							$contentUser = $this->wrapEditLink(htmlspecialchars($userRow['username'].' ('.$userRow['uid'].')'), 'be_users', 	$userRow['uid']);

								// Use different row color if record was edited by current user
							if ($userRow['uid']==$BE_USER->user['uid']) {
							$tableLayout[$tr]['tr'] = array('<tr class="bgColor5">','</tr>');
							}
						}

							// Add row to table
						$td=0;
						$table[$tr][$td++] = $contentPageLink;
						$table[$tr][$td++] = $contentElementLink;
						$table[$tr][$td++] = $contentUser;
						$table[$tr][$td++] = $contentAge;
						$tr++;
						break;
					} else {
						$n++;
					}
				}
			}
		}

			// Return rendered table
		return $this->doc->table($table, $tableLayout);
	}


	/**
	 * Returns a linked icon with title from a record
	 *
	 * @param   string      Table name (tt_content,...)
	 * @param   array       Record array
	 * @return  string      Rendered icon
	 */
	function getItemFromRecord($table, $row) {
		global $BACK_PATH, $LANG, $TCA, $BE_USER;

		$iconAltText = t3lib_BEfunc::getRecordIconAltText($row, $table);

			// Prepend table description for non-pages tables
		if(!($table=='pages')) {
			$iconAltText = $LANG->sl($TCA[$table]['ctrl']['title']).': '.$iconAltText;
		}

			// Create record title or rootline for pages if option is selected
		if($table=='pages' AND $this->MOD_SETTINGS['showRootline']) {
			$elementTitle = t3lib_BEfunc::getRecordPath($row['uid'], '1=1', 0);
			$elementTitle = t3lib_div::fixed_lgd_cs($elementTitle, -($BE_USER->uc['titleLen']));
		} else {
			$elementTitle = t3lib_BEfunc::getRecordTitle($table, $row, 1);
		}

			// Create icon for record
		$elementIcon = t3lib_iconworks::getIconImage($table, $row, $BACK_PATH, 'class="c-recicon" title="'.$iconAltText.'"');

			// Return item with edit link
		return $this->wrapEditLink($elementIcon.$elementTitle, $table, $row['uid']);
	}


	/**
	 * Wraps an edit link around a string.
	 * Creates a page module link for pages, edit link for other tables.
	 *
	 * @param   string      The string to be wrapped
	 * @param   string      Table name (tt_content,...)
	 * @param   integer     uid of the record
	 * @return  string      Rendered link
	 */
	function wrapEditLink($str, $table, $id)    {
		global $BACK_PATH, $LANG, $BE_USER;

		if($table=='pages') {
			$editOnClick = "top.fsMod.recentIds['web']=".$id.";top.goToModule('web_layout',1);";
		} else {
			$params = '&edit['.$table.']['.$id.']=edit';
			$editOnClick = t3lib_BEfunc::editOnClick($params, $BACK_PATH);
		}
		return '<a href="#" onclick="'.htmlspecialchars($editOnClick).'">'.$str.'</a>'; ;
	}

}
	 
	 
	 
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ml_informer/mod1/index.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ml_informer/mod1/index.php']);
}
	 
	 
	 
	 
// Make instance:
$SOBE = t3lib_div::makeInstance('tx_mlinformer_module1');
$SOBE->init();
 
// Include files?
foreach($SOBE->include_once as $INC_FILE) include_once($INC_FILE);
	 
$SOBE->main();
$SOBE->printContent();
	 
?>
